// Direct3DRM.h: CDirect3DRM NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECT3DRM_H__DEE45BA1_9522_11D2_B316_FBC9BE57D21A__INCLUDED_)
#define AFX_DIRECT3DRM_H__DEE45BA1_9522_11D2_B316_FBC9BE57D21A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DirectDraw.h"
#include "DirectDrawSurface.h"
#include "Direct3DIM.h"

#include "D3DFrame.h"
#include "D3DMeshBuilder.h"
#include "D3DLight.h"

class CDirect3DRM  
{
public:
	CDirect3DRM();
	virtual ~CDirect3DRM();

	bool Initialize( CDirectDraw* pDD , CDirectDrawSurface* pBack  , CDirect3DIM* pIM = NULL );
	void ReleaseAll();

	void Tick( double time );
	void Render();
	void NormalClear();
	void ForceClear( RECT* rc = NULL );

	void ChangeViewport( RECT* rc , double back , double front , double field );

	CD3DFrame* SetCamera( CD3DFrame* newCamera );
	CD3DFrame* SetScene( CD3DFrame* newScene );

	// mԂ֐Rc
	bool CreateFrame( CD3DFrame* pF , CD3DFrame* pParent );
	bool CreateMeshBuilder( CD3DMeshBuilder* pM , LPCTSTR xName );
	bool CreateLight( CD3DLight* pL,D3DRMLIGHTTYPE type,COLORREF cl);

private:
	bool m_bInit;

	IDirect3DRM3* m_pDirect3DRM;
	IDirect3DRMDevice3* m_pDirect3DRMDevice;
	IDirect3DRMViewport2* m_pDirect3DRMViewport;

	CD3DFrame* m_pScene;
	CD3DFrame* m_pCamera;
};

#endif // !defined(AFX_DIRECT3DRM_H__DEE45BA1_9522_11D2_B316_FBC9BE57D21A__INCLUDED_)
